/*                                                     -*- linux-c -*-
    Copyright (C) 2004 Tom Szilagyi

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    $Id: sound.h,v 1.3 2004/06/09 18:58:17 tszilagyi Exp $
*/


#ifndef _sound_h
#define _sound_h



unsigned long sample_rate;
jack_client_t * client;
const char ** ports_in;
const char ** ports_out;

jack_port_t * in_L_port;
jack_port_t * in_R_port;
jack_port_t * out_L_port;
jack_port_t * out_R_port;

void comp_coeffs(void);
void load_revtype_data(void);
void sound_init(void);
int process(jack_nframes_t nframes, void *arg);
void process_impresp(float * data, long int nframes);
void jack_shutdown(void *arg);





#endif /* _sound_h */
